/* Programmer: Steven Farago
 * Class:      EEL 5666
 * Description: This file is the primary location for the behaviors
                that control the Capture the Flag robots
 */


/* Concentrates all (or at least most) global variable definitions and
   define statements in one place
*/


#define BEHAVIOR_COUNT 9
#define BEHAVIOR_INDEX 6

#define IR_LEDS *(unsigned char *)(0x7000)
#define EXP_PORT *(unsigned char *)(0x4000)

#define FRONT_FOUR 0x06

#define TRUE 1
#define FALSE 0

/* ***** Overall game state globals *** */
int done;


/* **** Bradenburg defs **** */
int turns;
int last_turn;
#define LEFT 1
#define RIGHT -1



/* **** Turn_180 globals **** */
int turn180_active;


/* **** Motor Stuff **** */
int cur_m0;
int cur_m1;
int target_m0;
int target_m1;


int behavior[BEHAVIOR_COUNT][BEHAVIOR_INDEX];
/* Definition of behavior indexes */
#define MOTOR0 0
#define MOTOR1 1
#define DEFERRED_OP 2
#define LAST_OP 3
#define PRIORITY 4
#define MODULUS 5

/* Behavior modules */
#define DEFAULT 0
#define BUMP 1
#define IR_AVOID 2
#define BRADENBURG 3
#define DISABLED 4
#define IR_FOLLOW 5
#define SEEK_FLAG 6
#define TURN_180 7
#define GAME_OVER 8

/* Behavior controller array */
int priority[BEHAVIOR_COUNT];
int last_roam_behavior;
int last_behavior;


#define ROAM_ACTIVE 0
#define ROAM_PASSIVE 1
#define SEEK_MY_FLAG 2
#define SEEK_MY_HOME 3
#define WRONG_WAY    4



/* Speed defs */
#define FAST 90
#define MED 60
#define SLOW 30

/* ***** CDS calibration vars ****** */
int ncds_mid_nom, ncds_rt_nom, ncds_lt_nom;
int pcds_up_nom, pcds_down_nom;

/* Sensor globals */
#define ENEMY -1
#define FRIENDLY 1
#define NONE 0

int ir_FL, ir_FR, ir_LL, ir_RR, ir_SL, ir_SR, ir_BK;
int bump_FL, bump_FR, bump_BK;
int pcds_up, pcds_down, ncds_LT, ncds_RT, ncds_MID;
int active_ir, passive_ir;
int see_flag, got_flag;
int had_flag;


/* Controller variables */ 
int flag_acquired;
