/* Programmer: Steven Farago
 * Class:      EEL 5666
 * Description: This file is the primary location for the behaviors
                that control the Capture the Flag robots
 */

/* Localizes all pin/port mappings in one place.  Minor changes in hardware
   need only be updated here.  No other code changes should be necessary
*/

#define IR_FL_PORT 2
                      /* HC11 pin 47                                  */
#define IR_FR_PORT 1
                      /* HC11 pin 45                                  */
#define IR_LL_PORT 3
                      /* HC11 pin 49                                  */
#define IR_RR_PORT 0
                      /* HC11 pin 43                                  */
#define IR_SL_PORT 1
                      /* HC11 pin                                     */
#define IR_SR_PORT 1
                      /* HC11 pin                                     */
#define IR_BK_PORT 1
                      /* HC11 pin                                     */


#define BUMP_FL_PORT 6
                      /* HC11 pin 48                                    */
#define BUMP_FR_PORT 5
                      /* HC11 pin 46                                    */
#define BUMP_BK_PORT 4
                      /* HC11 pin 44                                    */

#define NCDS_LEFT 12 
                     /* HC11 pin analog exp 12 */   
#define NCDS_MID 13
                     /* HC11 pin analog exp 13 */
#define NCDS_RIGHT 14
                     /* HC11 pin analog exp 14 */

#define PCDS_UP 11 
                     /* HC11 pin analog exp 11 */   
#define PCDS_DOWN 10
                     /* HC11 pin analog exp 10 */
#define MAG_FLAG 9
                     /* HC11 pin analog exp 9  */





/* Speaker == HC11 pin 27 (oc1)                                       */
/* Broadcast Comm == HC11 pin exp port                                */
/* Receive Comm == HC11 pin exp port                                  */


/* Led memory maps */
#define FRONT_FOUR 0x06

