#include <hc11.h>
#include <mil.h>
#include "ports.h"
#include "defs.h"


/* Reads both old and expanded analog ports. 
 * Function is dependent on how MUX control is implemented (i.e. which
 * digital ports are used to control the MUX
 */

int exp_analog(int port)
{
 switch(port)
  { case 7 : CLEAR_BIT(EXP_PORT, 0xE0); return(analog(7)); break; 
    case 8 : CLEAR_BIT(EXP_PORT, 0xC0); SET_BIT(EXP_PORT, 0x20);  
             return(analog(7)); break;
    case 9 : CLEAR_BIT(EXP_PORT, 0xA0); SET_BIT(EXP_PORT, 0x40);  
             return(analog(7)); break;
    case 10: CLEAR_BIT(EXP_PORT, 0x80); SET_BIT(EXP_PORT, 0x60);  
             return(analog(7)); break;
    case 11: CLEAR_BIT(EXP_PORT, 0x60); SET_BIT(EXP_PORT, 0x80);  
             return(analog(7)); break;
    case 12: CLEAR_BIT(EXP_PORT, 0x40); SET_BIT(EXP_PORT, 0xA0);  
             return(analog(7)); break;
    case 13: CLEAR_BIT(EXP_PORT, 0x20); SET_BIT(EXP_PORT, 0xC0);  
             return(analog(7)); break;
    case 14: SET_BIT(EXP_PORT, 0xE0); return(analog(7)); break;
    default: return(analog(port)); break;
 }
}

/* Updates all sensor global variables at once */
void update_sensors()
{
 bump_FL=exp_analog(BUMP_FL_PORT);
 bump_FR=exp_analog(BUMP_FR_PORT);
 bump_BK=exp_analog(BUMP_BK_PORT);

 ir_FL=exp_analog(IR_FL_PORT);
 ir_FR=exp_analog(IR_FR_PORT);
 ir_LL=exp_analog(IR_LL_PORT);
 ir_RR=exp_analog(IR_RR_PORT);
 ir_SL=exp_analog(IR_SL_PORT);
 ir_SR=exp_analog(IR_SR_PORT);
 ir_BK=exp_analog(IR_BK_PORT);

 ncds_LT=ncds_lt_nom-exp_analog(NCDS_LEFT);
 ncds_RT=ncds_rt_nom-exp_analog(NCDS_RIGHT);
 ncds_MID=ncds_mid_nom-exp_analog(NCDS_MID);

 pcds_up=exp_analog(PCDS_UP);
 pcds_down=exp_analog(PCDS_DOWN);

 if (exp_analog(MAG_FLAG)<100) {got_flag=TRUE;} else {got_flag=FALSE;}
 if (pcds_up-pcds_down<-30) {see_flag=ENEMY;}
    else {if (pcds_up-pcds_down>30) {see_flag=FRIENDLY;}
          else {see_flag=NONE;}
 if (got_flag==TRUE) {had_flag=TRUE;}


         }
/*
printf("pcds_u %d   pcds_d %d   see_flag %d   \n",pcds_up,pcds_down,see_flag);
*/

}

/* Returns the index of the max number input */
int max(int a, int b, int c)
{if ((a>b) && (a>c)) {return(1);}
 if ((b>a) && (b>c)) {return(2);}
 if ((c>a) && (c>b)) {return(3);}
 return(1);
}

/* Returns a "pseudo" random number between 0 and i inclusive.  Since this
   "random" number is based on TCNT, a predictable variable, it is not
   truly random.
*/
int random(int i)
{unsigned int t;
 t=TCNT;
 return(t % i);
}


